# vim: set ts=4 sw=4 et:

%ifarch x86_64
%define driverarch _64
%else
%define driverarch %{nil}
%endif
%define underversion 6_30_223_141

Name:           broadcom-wl
BuildRequires:  kernel-source kernel-syms module-init-tools
License:        Proprietary
Group:          System/Kernel
Summary:        Wireless driver for Broadcom 43xx series of chips
Version:        6.30.223.141
Release:        2.1
Source0:        hybrid-v35%{driverarch}-nodebug-pcoem-%{underversion}.tar.gz
Source1:        README.SuSE
Source2:        broadcom-wl-blacklist
Patch0:		hybrid-v35-nodebug-pcoem-6_30_223_141-disable_timestamps.patch
Patch1:	        hybrid-v35-nodebug-pcoem-6_30_223_141-linux_recent.patch
BuildRoot:      %{_tmppath}/%{name}-%version-build
URL:            http://www.broadcom.com/support/802.11/linux_sta.php
Provides:       wl-kmod-common = %{version}
Requires:       broadcom-wl-kmp
ExclusiveArch:  %ix86 x86_64
%suse_kernel_module_package kdump um ec2

%description
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux®
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4321-,
and BCM4322-based hardware.

NOTE:           You must read the LICENSE.TXT file  before using this software.

%package KMP
Group:          System/Kernel
Summary:        Wireless driver for Broadcom 43xx series of chips

%description KMP
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux®
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4321-,
and BCM4322-based hardware.

NOTE:           You must read the LICENSE.TXT file  before using this software.

%prep
%setup -q -c hybrid-v35%{driverarch}-nodebug-pcoem-%{underversion}
%patch0
%patch1 -p1

%__sed -i 's/\r$//' lib/LICENSE.txt

set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    make -C /usr/src/linux-obj/%_target_cpu/$flavor modules \
       M=$PWD/obj/$flavor V=1
done

%install
# blacklist
mkdir -p %{buildroot}%{_sysconfdir}/modprobe.d/
mkdir -p %{buildroot}%{_docdir}/%{name}/
install -p -m0644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/modprobe.d/
install -p -m0644 %{SOURCE1} %{buildroot}%{_docdir}/%{name}/
install -p -m0644 source/lib/LICENSE.txt %{buildroot}%{_docdir}/%{name}/

%if %suse_version >= 1120
mv %buildroot/%{_sysconfdir}/modprobe.d/broadcom-wl-blacklist %buildroot/%{_sysconfdir}/modprobe.d/50-broadcom-wl-blacklist.conf
%endif


# Kernel module
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
     make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
        M=$PWD/obj/$flavor
done

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%files
%defattr(-,root,root)
%doc %dir %{_docdir}/%{name}
%doc %{_docdir}/%{name}/LICENSE.txt
%doc %{_docdir}/%{name}/README.SuSE
%if %suse_version >= 1120
%config(noreplace) %{_sysconfdir}/modprobe.d/50-broadcom-wl-blacklist.conf
%else
%config(noreplace) %{_sysconfdir}/modprobe.d/broadcom-wl-blacklist
%endif

%changelog
* Thu Oct 17 2013 javier@opensuse.org
- Readded time stamp patch
- Renamed patches
- linux recent patch is now applied to any version
* Thu Oct 17 2013 javier@opensuse.org
- Update to 6.30.223.141
  + Upgraded to support 3.8.x
  + Added 4352 support
  + Dropped WEXT support
- Added linux-recent.patch from Arch Linux
- Removed old patches
* Fri Sep  7 2012 oliver.bengs@opensuse.org
- added abiupdate and switch_to to build in openSUSE > 1210
* Sun Nov 13 2011 pascal.bleser@opensuse.org
- fix the LICENSE.txt EOL
- remove build timestamps which cause unnecessary syncs
* Wed Nov  9 2011 javier@opensuse.org
- Update to v5.100.82.112
  + Supports monitor mode
  + Supports cfg80211
  + Supports hidden networks
  + Supports rfkill
  + Issue #72238 - 20%% lower throughput on channels 149, 153, 157, and 161
* Sat Apr 16 2011 pascal.bleser@opensuse.org
- added "brcm80211" to the blacklist
* Fri Mar  4 2011 gber@opensuse.org
- added broadcom-wl-5.100.82.38-fix-linux-2.6.37.patch which fixes
  the build with kernel versions >= 2.6.37 by using sema_init
  instead of init_MUTEX
* Fri Jan 14 2011 andrea@links2linux.de
- update to version 5.10.82.38
  + Support for bcm43227 and bcm43228
  + Fix for issue where iwconfig was sometime reporting rate incorrectly
  + Supports rfkill in kernels 2.6.31 to 2.6.36
  + Supports scan complete event (SIOCGIWSCAN)
  + Adds EAGAIN (busy signal) to query of scan results
  + Following fixes (issues introduced in 5.100.57.13)
    Issue #87477 - 4313: DUT is not able to associate in WPA2-PSK TKIP/AES
    Issue #87533 - NetworkManager: 4313: Unable to associate to APs with WPA2-PSK
  + 4313 PHY fixes to improve throughput stability at different ranges
  + Fix for interop issues with different APs
  + Fix for hangs seen during Fn-F2 sequence
  - Support for rfkill in kernels 2.6.31 to 2.6.36
* Wed Nov  3 2010 alinm.elena@gmail.com
- updated to the version v5.60.246.2
- added the next patch to make it build for 2.6.34 and older kernels
- no need for the autoconf patched anymore
* Wed Aug 18 2010 andrea@links2linux.de
- fixed building on kernel >= 2.6.35
* Mon Jun 28 2010 andrea@opensuse.org
- added broadcom-wl_autoconf.patch to build on suse 11.3 kernel
* Fri Feb 19 2010 javier@opensuse.org
- updated to 5.60.48.36
* Tue Oct 27 2009 andrea@opensuse.org
- new upstream version 5.10.91.9.3
- removed previous patches now upstream
* Thu May  7 2009 Andrea Florio <andrea@links2linux.de> 5.10.91.9 6.pm.13
- new upstream version
- ISSUES FIXED IN THIS RELEASE: #72138 - SLED11 / Ubuntu 8.04: 43224 fails to associate after 6 hours
- KNOWN ISSUES AND LIMITATIONS:
  [#72238] - 20%%%% lower throughput on channels 149, 153, 157, and 161
  [#72324] - Ubuntu 8.04: cannot ping when Linux STA is IBSS creator with WEP enabled
  [#72216] - Ubuntu 8.04: standby/resume with WPA2 and wpa_supplicant causes a continuous assoc/disassoc loop
    (issue with wpa_supplicant, restarting wpa_supplicant fixes the issue)
* Fri Apr 10 2009 Andrea Florio <andrea@links2linux.de> 5.10.79.10 6.pm.10
- added new patch (wpa enterprise hang)
- rebuilt on new kernel
* Sat Mar 14 2009 Andrea Florio <andrea@links2linux.de> 5.10.79.10 5.pm.8
- new upstream version 5.10.79.10
* Sun Mar  1 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.14 5.pm.7
- diabled hidden network patch on suse <= 10.3, it have to be fixed or make fail
* Sun Feb  1 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.14 5.pm.3
- added hidden network patch: http://worldofxor.blogspot.com/2008/12/it-works-broadcom-official-wireless.html
* Wed Jan 28 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.14 5.pm.2
- new upstream version 5.10.27.14
* Sun Jan  4 2009 Andrea Florio <andrea@links2linux.de> 5.10.27.12 5.pm.0
- new upstream version 5.10.27.12
- This update from Broadcom has a new binary blob
- better locking and protection against the interrupt handler
-abstracted the ioctl code for kernels newer then 2.6.26.x
* Mon Dec 15 2008 Andrea Florio <andrea@links2linux.de> 5.10.27.11 5.pm.0
- new upstram version 5.10.27.11
- removed broadcom-wl-ssh_fix.patch
- ported patch  broadcom-wl-kernel-5.10.27.11_2_6_27.patch to new version
* Thu Dec  4 2008 Andrea Florio <andrea@links2linux.de> 5.10.27.6 4.pm.0
- added patch to build on kernel 2.6.27
- added patch to fix ssh issues
* Thu Dec  4 2008 Andrea Florio <andrea@links2linux.de> 5.10.27.6
- Fixed spec file
- build on x86_64
- added readme, license and blacklist file
